// LICENSE : MIT
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ThrowGenerator = exports.SpecGenerator = exports.NodeAssertGenerator = exports.SimpleGenerator = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _util = require("./util");

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var doctrine = require("doctrine");

var SimpleGenerator = exports.SimpleGenerator = function () {
  function SimpleGenerator() {
    _classCallCheck(this, SimpleGenerator);
  }

  _createClass(SimpleGenerator, [{
    key: "assert",
    value: function assert(expression) {
      var trimmedExpression = (0, _util.trimSpaceEachLine)(expression.split("\n")).join("");
      return "console.assert(" + trimmedExpression + ");";
    }
  }]);

  return SimpleGenerator;
}();

var NodeAssertGenerator = exports.NodeAssertGenerator = function () {
  function NodeAssertGenerator() {
    _classCallCheck(this, NodeAssertGenerator);
  }

  _createClass(NodeAssertGenerator, [{
    key: "assert",
    value: function assert(expression) {
      var trimmedExpression = (0, _util.trimSpaceEachLine)(expression.split("\n")).join("");
      return "assert(" + trimmedExpression + ", 'Invalid JSDoc: " + trimmedExpression + "');";
    }
  }]);

  return NodeAssertGenerator;
}();

var SpecGenerator = exports.SpecGenerator = function () {
  function SpecGenerator(tag) {
    _classCallCheck(this, SpecGenerator);

    this.nameOfValue = tag.name;
    this.typeString = doctrine.type.stringify(tag.type, { compact: true });
    this.jsdocLikeString = "@" + tag.title + " {" + this.typeString + "} " + tag.name;
  }

  _createClass(SpecGenerator, [{
    key: "assert",
    value: function assert(expression) {
      var trimmedExpression = (0, _util.trimSpaceEachLine)(expression.split("\n")).join("");
      var title = "TypeError: babel-plugin-jsdoc-to-assert";
      var expectedMessage = "Expected type: " + this.jsdocLikeString;
      var actualMessage = "Actual value:";
      var actualValue = this.nameOfValue;
      return "if(!(" + trimmedExpression + ")){\n      console.error('" + title + "\\n" + expectedMessage + "\\n" + actualMessage + "', " + actualValue + ");\n      console.assert(" + trimmedExpression + ", 'Invalid JSDoc: " + trimmedExpression + "');\n}";
    }
  }]);

  return SpecGenerator;
}();

var ThrowGenerator = exports.ThrowGenerator = function () {
  function ThrowGenerator() {
    _classCallCheck(this, ThrowGenerator);
  }

  _createClass(ThrowGenerator, [{
    key: "assert",
    value: function assert(expression) {
      var trimmedExpression = (0, _util.trimSpaceEachLine)(expression.split("\n")).join("");
      return "if(!(" + trimmedExpression + ")){ throw new TypeError('Invalid JSDoc: " + trimmedExpression + "'); }";
    }
  }]);

  return ThrowGenerator;
}();
//# sourceMappingURL=generators.js.map